require 'pry'

module AddingMultiples
    class CLI

        # greeting and directions for the user
        def initialize
            puts
            puts "Hello! Thank you for taking the time to try this out."
            puts "This tool will add the multiples (up to 1,000) of any positive integers you choose." 
            puts "In the prompt below, please enter a positive integer to get started."
        end

        # the order in which methods are called
        def call
            get_input
        end

        # get input from the user
        def get_input
            @i = 0
            @integer = []

            get_positive_integer 
        end

        # get a positive integer from the user
        def get_positive_integer
            puts "\nPlease enter a positive integer:"
            @integer << gets.strip

            if @integer[@i].match(/\d+/)
                @i += 1 
                get_another_integer  
            else
                get_positive_integer
            end  
        end

        # ask user for another integer
        def get_another_integer
            input = ""
            puts "\nPlease enter another positive integer:"
            @integer << gets.strip

            if @integer[@i].match(/\d+/)
                sum_integer_multiples
            else
                get_another_integer
            end  
        end

        #loop through multiples and compare to range [1-1000], consider allowing user input for range
        def sum_integer_multiples
            @range = [1, 1000]
            @sum = 0

            @integer.each do |i|
                integer = i.to_i
                @multiple = 0
                while @multiple < @range[1]
                    calculate_sum
                    @multiple += integer
                end
            end
            
            # sum common multiples and subtract from total
            sum_common_multiples
            subtract_common_multiples

            puts "The sum of the multiples of the integers #{@integer} that are less than #{@range[1]} is #{@sum}"

        end

        # add multiples to sum
        def calculate_sum
            @sum += @multiple
        end
        
        # sum common multiples
        def sum_common_multiples
            @range = [1, 1000]
            @least_common_multiple = 15
            @common_multiples_sum = 0
            @multiple = 0


            while @multiple < @range[1]
                @common_multiples_sum += @multiple
                @multiple += @least_common_multiple
            end
        end

        #calculate least common multiple
        def calculate_least_common_multiple
            integer_0 = @integer[0].to_i
            integer_1 = @integer[1].to_i
            @least_common_multiple = integer_0 * integer_1

        end        

        # subtract common multiples
        def subtract_common_multiples
            @sum -= @common_multiples_sum
        end

              
    end
end
